/**
 * @(#)MinoidsCounterListener.java
 * @author JLMJ
 * @date 2001-10-11
 */
package minoids1.counter;

import minoids1.Box;
import minoids1.Bits;
import java.util.EventObject;

public class MinoidsCounterEvent extends EventObject
{
    private Box box;
    private int numberOfMinoids;
    private Bits[] minoidsInBox;
    
    public MinoidsCounterEvent(Object source, TranslationsCounter counter) {
        super(source);
        this.box = counter.getBox();
        this.numberOfMinoids = counter.getTranslations();
        this.minoidsInBox = counter.getMinoidsInBox();
    }
    
    public MinoidsCounterEvent(Object source, int numberOfMinoids) {
        super(source);
        this.numberOfMinoids = numberOfMinoids;
        this.box = null;
        this.minoidsInBox = null;
    }

    public Box getBox() {
        return box;
    }
    
    public int getNumberOfMinoids() {
        return numberOfMinoids;
    }

    public Bits[] getMinoidsInBox() {
        return minoidsInBox;
    }
    
    public Bits getMinoidInBox(int pos) {
        if (pos < 0 || pos >= minoidsInBox.length)
            return null;
        return minoidsInBox[pos];
    }
}



